processargs(arg)

if arg.switches.h then

print[[

     grid2vg xxx.{grid|sg|ele} 

      creates voronoi snippets for the given grid.

]]

end

i=1
inputfile=arg.files[i]
while inputfile do

basename,ext=splitfilename(inputfile)
print "Create grid ..."
g=gRead(inputfile)
gCorrectOrientation(g)

print "Create Edgewise Voronoi ...."
vs= vsCreateEdgewise(g);

gPrintStatus(g)


if arg.switches.check  then
   if not arg.switches.noM then
      print "Check M Property..."
      sys=FVSystem{grid=g,neq=1}
      print("x1")
      fvsFreezeSpecies(sys)
      print("x2")
      sys.is_linear=1
      print("x21")
      sys.bcval[1][1]=1
      print("x22")
      sys.bctype[1][1]=1
      print("x3")
      sol=da2CreateFVS(sys);
      print("x4")

      vset(0,sol)
      print("x5")

      sol=varVaryInterval(sys.tvar,sol,0,1.0e-10);
            print("x6")

      fvsPrintMatrix(sys,2+8)
   end

   if InConstraints then
      print "Check constraints.."
      coord=vs.VCoord
      n=da2NRow(coord)
      d=da2NCol(coord)
      noor=0
      for i=1,n do
	 oor=InConstraints(coord[i])
	 if oor then 
	    printf("Point %d out of range:",i)
	    for j=1,d do printf(" % 10.5e",coord[i][j]) end
	    printf("\n")
	    noor=noor+1
	 end
      end
      printf("%d voronoi point(s) out of range\n-------------------------------------\n",noor)
   end

   
end

if arg.switches.v then

print "View  Voronoi..."

   viewer=glViewer{title="pdelib2 vsconvert", w=400,h=400}
   gView(viewer,g);
   vsView(viewer,vs)
   glvWait();
end
--print "Write grid..."
--gWrite(g,basename..".sg")
print "Write Voronoi..."
vsDump(vs,basename..".vg")
print(basename..".vg")


i=i+1
inputfile=arg.files[i]

end


